(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/common/http'), require('rxjs/operators'), require('prismjs'), require('prismjs/components/prism-typescript'), require('prismjs/components/prism-bash'), require('rxjs'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('angular-exemplify', ['exports', '@angular/core', '@angular/common', '@angular/common/http', 'rxjs/operators', 'prismjs', 'prismjs/components/prism-typescript', 'prismjs/components/prism-bash', 'rxjs', '@angular/forms'], factory) :
    (global = global || self, factory(global['angular-exemplify'] = {}, global.ng.core, global.ng.common, global.ng.common.http, global.rxjs.operators, global.prismjs, null, null, global.rxjs, global.ng.forms));
}(this, function (exports, core, common, http, operators, prismjs, prismTypescript, prismBash, rxjs, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UtilitiesService = /** @class */ (function () {
        function UtilitiesService() {
        }
        /* parse html from and return element matched with selector */
        /* parse html from and return element matched with selector */
        /**
         * @param {?} template
         * @param {?} selector
         * @return {?}
         */
        UtilitiesService.prototype.parseHtml = /* parse html from and return element matched with selector */
        /**
         * @param {?} template
         * @param {?} selector
         * @return {?}
         */
        function (template, selector) {
            /** @type {?} */
            var parser = new DOMParser();
            /** @type {?} */
            var htmlTemplate = '';
            try {
                htmlTemplate = typeof template !== 'string' ? template['_data'].componentView.component.viewContainerRef['_view'].component.constructor['__annotations__'][0].template : template;
            }
            catch (e) {
                console.warn('Exemplify: couldn\'t retrieve html for "' + selector + '", most likely due to annotations being removed with aot build. Referer to the following issue for more info and workaround:', 'https://github.com/hjalmers/angular-exemplify/issues/15');
            }
            /** @type {?} */
            var output = '';
            /** @type {?} */
            var markupExampleCode = parser.parseFromString(htmlTemplate, 'text/html').querySelectorAll(selector);
            if (markupExampleCode.length === 0 && htmlTemplate !== '') {
                console.warn('Exemplify: no element matched selector, no markup returned.');
            }
            for (var i = 0; i < markupExampleCode.length; i++) {
                output += markupExampleCode[i].outerHTML + '\n';
            }
            return output === '' ? 'no elements matched: "' + selector + '"' : output;
        };
        UtilitiesService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        UtilitiesService.ctorParameters = function () { return []; };
        /** @nocollapse */ UtilitiesService.ngInjectableDef = core.defineInjectable({ factory: function UtilitiesService_Factory() { return new UtilitiesService(); }, token: UtilitiesService, providedIn: "root" });
        return UtilitiesService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExemplifyComponent = /** @class */ (function () {
        function ExemplifyComponent(viewContainerRef, utilities) {
            this.viewContainerRef = viewContainerRef;
            this.utilities = utilities;
            this._escapeStrings = [];
            this._sources = [];
            this._show = true;
            this._defaultTexts = {
                markup: 'markup',
                copy: 'Copy',
                show: 'Show',
                hide: 'Hide',
                sourceNotFound: 'Source not found',
                copySuccess: 'Code snippet successfully copied to clipboard!',
                copyError: 'Copy to clipboard failed!'
            };
            this._texts = this._defaultTexts;
        }
        Object.defineProperty(ExemplifyComponent.prototype, "texts", {
            get: /**
             * @return {?}
             */
            function () {
                return this._texts;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._texts = __assign({}, this._defaultTexts, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExemplifyComponent.prototype, "escapeStrings", {
            get: /**
             * @return {?}
             */
            function () {
                return this._escapeStrings;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._escapeStrings = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExemplifyComponent.prototype, "show", {
            get: /**
             * @return {?}
             */
            function () {
                return this._show;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._show = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExemplifyComponent.prototype, "sources", {
            get: /**
             * @return {?}
             */
            function () {
                return this._sources;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._sources = value.map((/**
                 * @param {?} snippet
                 * @return {?}
                 */
                function (snippet) {
                    return {
                        name: snippet.name || snippet.src.split('/').pop(),
                        lang: snippet.lang,
                        src: snippet.src,
                        selector: snippet.selector
                    };
                }));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExemplifyComponent.prototype, "selector", {
            get: /**
             * @return {?}
             */
            function () {
                return this._selector;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._selector = value;
                // get parsed html template from view container reference using selector
                /** @type {?} */
                var parsedHtml = this.utilities.parseHtml(this.viewContainerRef, this.selector);
                this.addSnippet({
                    name: this.texts.markup,
                    src: this.escapeString(parsedHtml, this.escapeStrings),
                    lang: 'markup'
                });
            },
            enumerable: true,
            configurable: true
        });
        /* set active snippet */
        /* set active snippet */
        /**
         * @param {?} snippet
         * @return {?}
         */
        ExemplifyComponent.prototype.setActiveSnippet = /* set active snippet */
        /**
         * @param {?} snippet
         * @return {?}
         */
        function (snippet) {
            this.activeSnippet = __assign({}, snippet, { isActive: this.show });
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        ExemplifyComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            // when inputs are changed, update active snippet if no snippet is active
            if (!this.activeSnippet) {
                // set first snippet in array to be active by default
                this.setActiveSnippet(this.sources[0]);
            }
        };
        /* compare options */
        /* compare options */
        /**
         * @param {?} o1
         * @param {?} o2
         * @return {?}
         */
        ExemplifyComponent.prototype.compareFn = /* compare options */
        /**
         * @param {?} o1
         * @param {?} o2
         * @return {?}
         */
        function (o1, o2) {
            return o1 && o2 ? o1.name === o2.name : o1 === o2;
        };
        /* prepend snippet to list of snippet */
        /* prepend snippet to list of snippet */
        /**
         * @private
         * @param {?} snippet
         * @return {?}
         */
        ExemplifyComponent.prototype.addSnippet = /* prepend snippet to list of snippet */
        /**
         * @private
         * @param {?} snippet
         * @return {?}
         */
        function (snippet) {
            this.sources = __spread([snippet], this.sources);
        };
        /* escape strings, by default angular will turn all directives and attributes into lower case when rendering the html, but we want to show them as they should be entered */
        /* escape strings, by default angular will turn all directives and attributes into lower case when rendering the html, but we want to show them as they should be entered */
        /**
         * @private
         * @param {?} html
         * @param {?} strings
         * @return {?}
         */
        ExemplifyComponent.prototype.escapeString = /* escape strings, by default angular will turn all directives and attributes into lower case when rendering the html, but we want to show them as they should be entered */
        /**
         * @private
         * @param {?} html
         * @param {?} strings
         * @return {?}
         */
        function (html, strings) {
            // add angular attributes and directives to the list of strings to escape
            /** @type {?} */
            var stringsToEscape = __spread(strings, ['*ngIf', '*ngFor', '*ngPluralCase', '*ngSwitchCase', '*ngSwitchDefault', 'ngClass', 'ngPlural', 'ngStyle', 'ngSwitch', 'ngTemplateOutlet', '[ngIf]', '[ngFor]', '[ngForOf]', '[ngPluralCase]', '[ngSwitchCase]', '[ngSwitchDefault]', 'ngModel']);
            // loop through strings to escape and replace the lowercase version with the escaped version
            stringsToEscape.map((/**
             * @param {?} string
             * @return {?}
             */
            function (string) {
                /** @type {?} */
                var lower = new RegExp('\\' + string.toLowerCase(), 'g');
                html = html.replace(lower, string).replace('=""', '');
            }));
            return html;
        };
        ExemplifyComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'exemplify',
                        template: "<ul class=\"nav nav-tabs d-none d-sm-flex\">\n  <li class=\"nav-item\" *ngFor=\"let snippet of sources\">\n    <button class=\"nav-link\" [ngClass]=\"{'active': snippet.name === activeSnippet.name}\"\n            (click)=\"setActiveSnippet(snippet)\">{{snippet.name}}\n    </button>\n  </li>\n</ul>\n<select class=\"custom-select d-sm-none\" [compareWith]=\"compareFn\" [(ngModel)]=\"activeSnippet\">\n  <option *ngFor=\"let snippet of sources\" [ngValue]=\"snippet\">{{snippet.name}}</option>\n</select>\n<code-snippet [snippet]=\"activeSnippet\" [texts]=\"texts\"></code-snippet>\n",
                        styles: [":host{display:block;position:relative;margin-top:1rem}:host:hover ::ng-deep.btn-group{opacity:1;-webkit-transform:translate3d(0,0,0);transform:translate3d(0,0,0)}:host:hover ::ng-deep.btn-group .btn.not-active{text-decoration:underline}.nav-link:not(.active){border-bottom:inherit}@media only screen and (max-width:576px){.custom-select{padding-right:114px;background-position-x:calc(100% - 114px - 8px)}}"]
                    }] }
        ];
        /** @nocollapse */
        ExemplifyComponent.ctorParameters = function () { return [
            { type: core.ViewContainerRef },
            { type: UtilitiesService }
        ]; };
        ExemplifyComponent.propDecorators = {
            texts: [{ type: core.Input }],
            escapeStrings: [{ type: core.Input }],
            show: [{ type: core.Input }],
            sources: [{ type: core.Input }],
            selector: [{ type: core.Input }]
        };
        return ExemplifyComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function _window() {
        // return the global native browser window object
        return window;
    }
    var WindowRef = /** @class */ (function () {
        function WindowRef() {
        }
        Object.defineProperty(WindowRef.prototype, "nativeWindow", {
            get: /**
             * @return {?}
             */
            function () {
                return _window();
            },
            enumerable: true,
            configurable: true
        });
        WindowRef.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        WindowRef.ctorParameters = function () { return []; };
        /** @nocollapse */ WindowRef.ngInjectableDef = core.defineInjectable({ factory: function WindowRef_Factory() { return new WindowRef(); }, token: WindowRef, providedIn: "root" });
        return WindowRef;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Prism tries to highlight the whole document on DOMContentLoad.
    // Unfortunately with webpack the only way of disabling it
    // is by simply forcing it to highlight no elements -> []
    prismjs.hooks.add('before-highlightall', (/**
     * @param {?} env
     * @return {?}
     */
    function (env) {
        env['elements'] = [];
    }));
    var CodeHighlightService = /** @class */ (function () {
        function CodeHighlightService() {
        }
        /**
         * @param {?} code
         * @param {?} lang
         * @return {?}
         */
        CodeHighlightService.prototype.highlight = /**
         * @param {?} code
         * @param {?} lang
         * @return {?}
         */
        function (code, lang) {
            try {
                return prismjs.highlight(code.trim(), prismjs.languages[lang]);
            }
            catch (error) {
                console.log(error);
            }
        };
        CodeHighlightService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */ CodeHighlightService.ngInjectableDef = core.defineInjectable({ factory: function CodeHighlightService_Factory() { return new CodeHighlightService(); }, token: CodeHighlightService, providedIn: "root" });
        return CodeHighlightService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CodeSnippetComponent = /** @class */ (function () {
        function CodeSnippetComponent(_codeHighlight, http, windowRef, utilities) {
            this._codeHighlight = _codeHighlight;
            this.http = http;
            this.windowRef = windowRef;
            this.utilities = utilities;
            this.isActive = true;
            this.showCopyNotice = false;
            this.$unsubscribe = new rxjs.Subject();
            this._defaultTexts = {
                markup: 'markup',
                copy: 'Copy',
                show: 'Show',
                hide: 'Hide',
                sourceNotFound: 'Source not found',
                copySuccess: 'Code snippet successfully copied to clipboard!',
                copyError: 'Copy to clipboard failed!'
            };
            this._texts = this._defaultTexts;
            /**
             * Copy to clipboard
             */
            this.copyToClipboard = (/**
             * @param {?} text
             * @return {?}
             */
            function (text) {
                var _this = this;
                if (this.window.clipboardData && this.window.clipboardData.setData) {
                    // IE specific code path to prevent textarea being shown while dialog is visible.
                    return this.window.clipboardData.setData('Text', text);
                }
                else if (document.queryCommandSupported && document.queryCommandSupported('copy')) {
                    /** @type {?} */
                    var textarea = document.createElement('textarea');
                    textarea.textContent = text;
                    textarea.style.position = 'fixed'; // Prevent scrolling to bottom of page in MS Edge.
                    document.body.appendChild(textarea);
                    textarea.select();
                    try {
                        /** @type {?} */
                        var copy = document.execCommand('copy');
                        this.copyNotice = this.texts.copySuccess;
                        this.showCopyNotice = true;
                        return copy;
                    }
                    catch (ex) {
                        console.warn('Copy to clipboard failed.', ex);
                        this.copyNotice = this.texts.copyError;
                        this.showCopyNotice = true;
                        return false;
                    }
                    finally {
                        document.body.removeChild(textarea);
                        setTimeout((/**
                         * @return {?}
                         */
                        function () { return _this.showCopyNotice = false; }));
                    }
                }
            });
            this.window = this.windowRef.nativeWindow;
        }
        Object.defineProperty(CodeSnippetComponent.prototype, "texts", {
            get: /**
             * @return {?}
             */
            function () {
                return this._texts;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._texts = __assign({}, this._defaultTexts, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CodeSnippetComponent.prototype, "snippet", {
            get: /**
             * @return {?}
             */
            function () {
                return this._snippet;
            },
            set: /**
             * @param {?} snippet
             * @return {?}
             */
            function (snippet) {
                var _this = this;
                // guess file extension based on source file, note this won't work when source is inline or when raw-loader is used
                /** @type {?} */
                var e = snippet.src.split('.');
                /** @type {?} */
                var extension = e[e.length - 1];
                this._snippet = __assign({}, snippet, { code: snippet.src.substring(0, 4) === 'http' ? this.getSourceCode(snippet.src, snippet.selector) : rxjs.of(snippet.src), lang: snippet.lang || (extension.length > 4 ? 'markup' : extension) // if lang is omitted use extension if length is not greater than 4 otherwise default to markup
                 });
                // when snippet has loaded highlight the code and store the string representation too (needed for copying etc).
                this.snippet.code
                    .pipe(operators.takeUntil(this.$unsubscribe))
                    .subscribe((/**
                 * @param {?} code
                 * @return {?}
                 */
                function (code) {
                    _this.highlight(code, _this.snippet.lang);
                    _this.code = code; // store raw string representation
                }));
                this.toggleState(this.snippet.isActive !== false);
            },
            enumerable: true,
            configurable: true
        });
        /** Highlight, highlight code and update value of parsed snippet */
        /**
         * Highlight, highlight code and update value of parsed snippet
         * @param {?} code
         * @param {?} lang
         * @return {?}
         */
        CodeSnippetComponent.prototype.highlight = /**
         * Highlight, highlight code and update value of parsed snippet
         * @param {?} code
         * @param {?} lang
         * @return {?}
         */
        function (code, lang) {
            this.parsedSnippet = this._codeHighlight.highlight(code, lang);
        };
        /** Get source code */
        /**
         * Get source code
         * @private
         * @param {?} url
         * @param {?=} selector
         * @return {?}
         */
        CodeSnippetComponent.prototype.getSourceCode = /**
         * Get source code
         * @private
         * @param {?} url
         * @param {?=} selector
         * @return {?}
         */
        function (url, selector) {
            var _this = this;
            return this.http.get(url, { responseType: 'text' })
                .pipe(operators.map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                if (selector) {
                    return _this.utilities.parseHtml(data, selector);
                }
                else {
                    return data;
                }
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return console.log(error); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                if (error.error instanceof ErrorEvent) {
                    // a client-side or network error occurred
                    console.error('An error occurred:', error.error.message);
                }
                return rxjs.of(_this.texts.sourceNotFound);
            })));
        };
        /** Toggle state for code snippet toolbar */
        /**
         * Toggle state for code snippet toolbar
         * @param {?=} state
         * @return {?}
         */
        CodeSnippetComponent.prototype.toggleState = /**
         * Toggle state for code snippet toolbar
         * @param {?=} state
         * @return {?}
         */
        function (state) {
            this.isActive = state || !this.isActive;
        };
        /**
         * @return {?}
         */
        CodeSnippetComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.$unsubscribe.next();
            this.$unsubscribe.complete();
        };
        CodeSnippetComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'code-snippet',
                        template: "<div class=\"btn-group\" role=\"group\" aria-label=\"Code snippet toolbar\" *ngIf=\"code\">\n  <button class=\"btn btn-link\" (click)=\"toggleState()\" [ngClass]=\"{'not-active':!isActive}\">{{isActive ? texts.hide:texts.show}}</button>\n  <button class=\"btn btn-link\" (click)=\"copyToClipboard(code)\">{{texts.copy}}</button>\n</div>\n<div class=\"snippet-wrapper exemplify-backdrop\" [ngClass]=\"{'exemplify-hidden': !showCopyNotice }\" (dblclick)=\"copyToClipboard(code)\">\n  <pre class=\"language-{{snippet?.lang}}\" *ngIf=\"isActive\">\n    <code class=\"language-{{snippet?.lang}}\" [innerHTML]=\"parsedSnippet\"></code>\n  </pre>\n  <div class=\"copy-notice\" [ngClass]=\"{'exemplify-hidden': !showCopyNotice }\">\n    <span>{{copyNotice}}</span>\n  </div>\n</div>\n\n",
                        styles: [".btn-group{position:absolute;top:0;right:0}@media only screen and (min-width:576px){.btn-group{opacity:0;margin-top:2px;-webkit-transform:translate3d(0,10px,0);transform:translate3d(0,10px,0);transition:opacity .4s ease-in-out,transform .4s ease-out,-webkit-transform .4s ease-out}}@media only screen and (max-width:576px){.btn-group{width:114px;height:calc(2.25rem + 2px)}.btn-group .btn{height:100%;padding-right:.5rem;padding-left:.5rem}}.snippet-wrapper{position:relative}.snippet-wrapper.exemplify-backdrop::after{content:'';display:block;height:100%;width:100%;top:0;left:0;position:absolute;background:rgba(0,0,0,.75);z-index:0;opacity:1}.copy-notice{position:absolute;height:100%;width:100%;top:0;text-align:center;color:#fff;font-size:1.25rem;display:flex;justify-content:center;align-items:center;max-height:300px;z-index:1;opacity:1}.exemplify-hidden.copy-notice,.exemplify-hidden.exemplify-backdrop::after{transition:opacity .6s ease-out 1.4s,z-index 1ms 1.4s,height 1ms 2s;opacity:0;z-index:0;height:0}"]
                    }] }
        ];
        /** @nocollapse */
        CodeSnippetComponent.ctorParameters = function () { return [
            { type: CodeHighlightService },
            { type: http.HttpClient },
            { type: WindowRef },
            { type: UtilitiesService }
        ]; };
        CodeSnippetComponent.propDecorators = {
            texts: [{ type: core.Input }],
            snippet: [{ type: core.Input }]
        };
        return CodeSnippetComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExemplifyModule = /** @class */ (function () {
        function ExemplifyModule() {
        }
        ExemplifyModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule, http.HttpClientModule],
                        declarations: [ExemplifyComponent, CodeSnippetComponent],
                        exports: [ExemplifyComponent]
                    },] }
        ];
        return ExemplifyModule;
    }());

    exports.ExemplifyComponent = ExemplifyComponent;
    exports.ExemplifyModule = ExemplifyModule;
    exports.ɵa = UtilitiesService;
    exports.ɵb = CodeSnippetComponent;
    exports.ɵc = CodeHighlightService;
    exports.ɵd = WindowRef;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=angular-exemplify.umd.js.map
